gtest: Install the run_with_tmp script for convenience

This makes it possible for other tests to utilize the script.

Change-Id: I1bb6100e4018bad020817d569294704e267c2776
Signed-off-by: William A. Kennington III <wak@google.com>
diff --git a/src/meson.build b/src/meson.build
index 6ff400d..0b6be99 100644
--- a/src/meson.build
+++ b/src/meson.build
@@ -147,4 +147,13 @@
     description: 'C++ helper utilities',
     version: meson.project_version(),
     requires: stdplus_gtest_reqs)
+
+  install_data(
+    'run_with_tmp',
+    install_mode: 'rwxr-xr-x',
+    install_dir: get_option('bindir'))
+
+  meson.override_find_program('run_with_tmp', files('run_with_tmp'))
 endif
+
+run_with_tmp = find_program('run_with_tmp', native: true)
diff --git a/src/run_with_tmp b/src/run_with_tmp
new file mode 100755
index 0000000..8b8895a
--- /dev/null
+++ b/src/run_with_tmp
@@ -0,0 +1,14 @@
+#!/bin/bash
+TMPDIR="$(mktemp -d --tmpdir "${TMPTMPL-tmp.XXXXXXXXXX}")" || exit
+rmtmp() {
+  if [ -n "${TMP_DEBUG-}" ]; then
+    echo "Removing TMPDIR=$TMPDIR" >&2
+  fi
+  rm -rf -- "$TMPDIR"
+}
+trap rmtmp EXIT
+export TMPDIR
+if [ -n "${TMP_DEBUG-}" ]; then
+  echo "Exec $* with TMPDIR=$TMPDIR" >&2
+fi
+"$@"
diff --git a/test/meson.build b/test/meson.build
index 1f284a5..4ebf17f 100644
--- a/test/meson.build
+++ b/test/meson.build
@@ -79,7 +79,7 @@
   foreach t : gtests
     test(
       t,
-      files('run_with_tmp.sh'),
+      run_with_tmp,
       env: {'TMPTMPL': 'stdplus-test.XXXXXXXXXX'},
       args: executable(
         t.underscorify(), t + '.cpp',
diff --git a/test/run_with_tmp.sh b/test/run_with_tmp.sh
deleted file mode 100755
index 485d6a3..0000000
--- a/test/run_with_tmp.sh
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/bin/bash
-TMPDIR="$(mktemp -d --tmpdir "${TMPTMPL-tmp.XXXXXXXXXX}")" || exit
-trap 'rm -rf -- "$TMPDIR"' EXIT
-export TMPDIR
-echo "Exec $* with TMPDIR=$TMPDIR" >&2
-"$@"